
CoCoA-5 - Bug #1421

SEGV: error("")

20 Feb 2020 17:02 - John Abbott

Status: Closed Start date: 20 Feb 2020

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: bug Estimated time: 0.99 hour

Target version: CoCoA-5.3.0 Spent time: 1.05 hour

Description

The error function does not like having an empty string as argument: throws a fatal exception!

Reported vocally by Julian Danner.

History

#1 - 20 Feb 2020 17:03 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Not pretty!!

>>> error("");

CoCoAInterpreter: LineProviders.H:200: CoCoA::LexerNS::BaseException::BaseException(const string&): Assertion 

`reason.length()>0' failed.

Process cocoa5 aborted (core dumped)

 

Looks like a failed assertion...

#2 - 20 Feb 2020 17:06 - John Abbott

      explicit BaseException::BaseException(const std::string &reason) : reason(reason)

      {

        assert(reason.length()>0);

      }

 

Mmmm  :-/
#3 - 21 Feb 2020 12:44 - John Abbott

- % Done changed from 10 to 50

While it is hard to imagine how an empty error description could be useful, it is surely wrong that CoCoA-5 crashes.

So I plan to allow an empty description (and perhaps I'll replace it by a short message saying no description was given).

First impl compiles, but CoCoA-5 continues to behave as before... there is something wrong in the compilation mechanism!

#4 - 21 Feb 2020 12:59 - John Abbott

- Status changed from In Progress to Feedback

- Assignee set to John Abbott

- % Done changed from 50 to 90

- Estimated time set to 0.99 h

Not sure what the compilation problem in comment 3 was; it seems that starting CoCoA-5 from inside emacs, might sometimes start the old

version(???)

Anyway, it now works as expected.  An empty string is actually replaced by >>>> no description given <<<<

#5 - 26 Feb 2020 16:27 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100
